import persist
import string
import gpio
import re

var util = module('util')

util.init = def (m)
  class Util
    var base_topic

    def init()
      self.base_topic = 'melonfield/node/%s/'
    end

    def get_base_topic()
      return self.base_topic
    end
  
    def calc_battery_level(raw)
      # todo: calculate battery level from discharge curve
      return raw
    end

    def calc_soil_moisture(raw)
      var soil_moisture = (raw - 902.0) / (2750.0 - 902.0) * 100.0
      
      if soil_moisture > 100.0 
        return 0.0
      elif soil_moisture < 0.0
        return 100.0
      else 
        return 100.0 - soil_moisture
      end
    end

    def set_wakeup_led(value)
      gpio.digital_write(2, value)
    end
  end

  return Util()
end

return util
